Index: /anuga_core/documentation/user_manual/anuga_user_manual.tex
===================================================================
--- /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 4887)
+++ /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 4888)
@@ -1633,5 +1633,6 @@
 \end{methoddesc}
 
-\begin{methoddesc}  {add\_region\_from\_polygon}{self, polygon, tags=None,
+\begin{methoddesc}  {add\_region\_from\_polygon}{self, polygon, 
+segment_tags=None, region_tag=None
                                 max_triangle_area=None}
 Module: \module{pmesh.mesh},  Class: \class{Mesh}
@@ -1643,5 +1644,5 @@
 region boundary is described by the input \code{polygon}.  Additionally, the
 user specifies a list of segment tags, one for each edge of the
-bounding polygon.
+bounding polygon.  The regional tag is set using  \code{region}.
 
 \end{methoddesc}
Index: /anuga_core/source/anuga/pmesh/mesh.py
===================================================================
--- /anuga_core/source/anuga/pmesh/mesh.py	(revision 4887)
+++ /anuga_core/source/anuga/pmesh/mesh.py	(revision 4888)
@@ -731,5 +731,6 @@
             self.userVertices.append(v)
             
-    def add_hole_from_polygon(self, polygon, tags=None, geo_reference=None):
+    def add_hole_from_polygon(self, polygon, segment_tags=None,
+                              geo_reference=None):
         """
         Add a polygon with tags to the current mesh, as a region.
@@ -748,5 +749,6 @@
         it they can.       
         """
-        return self._add_area_from_polygon(polygon, tags=tags,
+        return self._add_area_from_polygon(polygon,
+                                           segment_tags=segment_tags,
                                            hole=True,
                                            geo_reference=geo_reference
@@ -754,6 +756,7 @@
 
         
-    def add_region_from_polygon(self, polygon, tags=None,
-                                max_triangle_area=None, geo_reference=None):
+    def add_region_from_polygon(self, polygon, segment_tags=None,
+                                max_triangle_area=None, geo_reference=None,
+                                region_tag=None):
         """
         Add a polygon with tags to the current mesh, as a region.
@@ -767,5 +770,7 @@
         polygon a list of points, in meters that describe the polygon
              (e.g. [[x1,y1],[x2,y2],...]
-        tags (e.g.{'wall':[0,1,3],'ocean':[2]})
+        segment_tags (e.g.{'wall':[0,1,3],'ocean':[2]}) add tags to the
+        segements of the region
+        region_tags  - add a tag to all of the triangles in the region.
 
         This returns the region instance (if a max_triangle_area is given),
@@ -777,13 +782,18 @@
             create_region = True
             
-        region = self._add_area_from_polygon(polygon, tags=tags,
+        region = self._add_area_from_polygon(polygon,
+                                             segment_tags=segment_tags,
                                              geo_reference=geo_reference,
                                              region=create_region)
         if max_triangle_area is not None:
             region.setMaxArea(max_triangle_area)
+        if region_tag is not None:
+            region.setTag(region_tag)
+        
+        
         return region
     
         
-    def _add_area_from_polygon(self, polygon, tags=None,
+    def _add_area_from_polygon(self, polygon, segment_tags=None,
                                geo_reference=None,
                                hole=False,
@@ -800,5 +810,6 @@
         polygon a list of points, in meters that describe the polygon
              (e.g. [[x1,y1],[x2,y2],...]
-        tags (e.g.{'wall':[0,1,3],'ocean':[2]})
+        segment_tags (e.g.{'wall':[0,1,3],'ocean':[2]})add tags to the
+        segements of the region.
 
         This returns the region instance, so if the user whats to modify
@@ -831,5 +842,5 @@
             segments.append( [lo, hi] ) 
         region_dict['segments'] = segments
-        region_dict['segment_tags'] = self._tag_dict2list(tags, N)
+        region_dict['segment_tags'] = self._tag_dict2list(segment_tags, N)
        
     
@@ -903,5 +914,5 @@
         tags = {tag:range(segment_count)}
         
-        return self._add_area_from_polygon(polygon, tags=tags,
+        return self._add_area_from_polygon(polygon, segment_tags=tags,
                                            region=region, hole=hole,
                                            geo_reference=center_geo_reference)
Index: /anuga_core/source/anuga/pmesh/mesh_interface.py
===================================================================
--- /anuga_core/source/anuga/pmesh/mesh_interface.py	(revision 4887)
+++ /anuga_core/source/anuga/pmesh/mesh_interface.py	(revision 4888)
@@ -229,5 +229,5 @@
     # Do bounding polygon
     m.add_region_from_polygon(bounding_polygon,
-                              tags=boundary_tags,
+                              segment_tags=boundary_tags,
                               geo_reference=poly_geo_reference)
 
Index: /anuga_core/source/anuga/pmesh/test_mesh.py
===================================================================
--- /anuga_core/source/anuga/pmesh/test_mesh.py	(revision 4887)
+++ /anuga_core/source/anuga/pmesh/test_mesh.py	(revision 4888)
@@ -1905,5 +1905,6 @@
         m=Mesh()
         region = m.add_region_from_polygon([[0,0],[1,0],[0,1]],
-                                  max_triangle_area = 88)
+                                  max_triangle_area = 88,
+                                           region_tag='cassady')
         self.failUnless(len(m.regions)==1,
                         'FAILED!')
@@ -1913,4 +1914,6 @@
                         'FAILED!')
         self.failUnless(len(m.userVertices)==3,
+                        'FAILED!')
+        self.failUnless(region.getTag()=='cassady',
                         'FAILED!')
        
@@ -2137,5 +2140,5 @@
         #m.export_mesh_file("aaat.msh")
         
-    def FIXMEtest_auto_set_geo_reference(self):
+    def NOTIMPLEMENTEDtest_auto_set_geo_reference(self):
         x=50000
         y=1000
Index: /anuga_validation/automated_validation_tests/fitting/validate_benchmark_fit.py
===================================================================
--- /anuga_validation/automated_validation_tests/fitting/validate_benchmark_fit.py	(revision 4887)
+++ /anuga_validation/automated_validation_tests/fitting/validate_benchmark_fit.py	(revision 4888)
@@ -37,6 +37,6 @@
             ,save=False
             )
-        print "time", time
-        print "mem", mem
+        #print "time", time
+        #print "mem", mem
         if host.find('tornado') == 0 or host.find('compute-1') == 0:
             # Tornado headnode or node