Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/test_util.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/test_util.py	(revision 4909)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/test_util.py	(revision 4910)
@@ -1399,5 +1399,5 @@
         
 
-    def test_gauges_sww2csv(self):
+    def test_sww2csv_gauges(self):
 
         def elevation_function(x, y):
@@ -1467,5 +1467,5 @@
 
         
-        gauges_sww2csv(sww.filename, 
+        sww2csv_gauges(sww.filename, 
                             points_file,
                             verbose=False,
@@ -1509,5 +1509,5 @@
 
 
-    def test_gauges_sww2csv1(self):
+    def test_sww2csv_gauges1(self):
         from anuga.pmesh.mesh import Mesh
         from anuga.shallow_water import Domain, Transmissive_boundary
@@ -1585,5 +1585,5 @@
         file_id.close()
 
-        gauges_sww2csv(sww.filename, 
+        sww2csv_gauges(sww.filename, 
                             points_file,
                             quantities=['Stage', 'elevation'],
Index: /anuga_core/source/anuga/abstract_2d_finite_volumes/util.py
===================================================================
--- /anuga_core/source/anuga/abstract_2d_finite_volumes/util.py	(revision 4909)
+++ /anuga_core/source/anuga/abstract_2d_finite_volumes/util.py	(revision 4910)
@@ -685,4 +685,9 @@
     """
 
+    msg = 'NOTE: A new function is available to create csv files from sww files called'
+    msg += 'sww2csv_gauges in anuga.abstract_2d_finite_volumes.util'
+    msg += 'PLUS another new function to create graphs from csv files called'   
+    msg += 'csv2timeseries_graphs in anuga.abstract_2d_finite_volumes.util'
+    print msg
     
     k = _sww2timeseries(swwfiles,
@@ -1494,4 +1499,25 @@
     return xc
 
+def make_plots_from_csv_file(directories_dic={dir:['gauge', 0, 0]},
+                                output_dir='',
+                                base_name='',
+                                plot_numbers=['3-5'],
+                                quantities=['Speed','Stage','Momentum'],
+                                assess_all_csv_files=True,
+                                extra_plot_name='test' ):
+    
+    print 'make_plots_from_csv_file has been replaced by csv2timeseries_graphs ',
+    print 'Please use "from anuga.shallow_water.util import csv2timeseries_graphs"'
+    
+    return csv2timeseries_graphs(directories_dic,
+                                 output_dir,
+                                 base_name,
+                                 plot_numbers,
+                                 quantities,
+                                 extra_plot_name,
+                                 assess_all_csv_files
+                                 )
+    
+
 def csv2timeseries_graphs(directories_dic={},
                             output_dir='',
@@ -1504,6 +1530,8 @@
                             verbose=False):
                                 
-    """    WARNING!! NO UNIT TESTS... could make some as to test filename..but have
+    """    
+    WARNING!! NO UNIT TESTS... could make some as to test filename..but have
     spend ages on this already...
+    AND NOTE Create_latex is NOT implemented yet.
     
     
@@ -1571,5 +1599,13 @@
     
     """
-    import pylab# 
+    import pylab 
+    try: 
+        import pylab
+    except ImportError:
+        msg='csv2timeseries_graphs needs pylab to be installed correctly'
+        raise msg
+            #ANUGA don't need pylab to work so the system doesn't 
+            #rely on pylab being installed 
+        return
     from os import sep
     from anuga.shallow_water.data_manager import \
@@ -1927,7 +1963,8 @@
                                 
     """     
-    NOTE! DOES not work 100% yet. eg don't use assess_all_csv_files=True
-    everything else is ok?                 
-    Use sww2timeseries....            
+    NOTE! This code has NOT been removed as it is very close to working 
+    the same as the current code for sww2timeseries_graphs HOWEVER IT WOULD
+    BE MUCH NICER!! instead of explicit if statments it uses loops and halves
+    the number of lines of code.... but it doesn't work yet           
     
     Read in csv files that have the right header information and
@@ -2271,5 +2308,5 @@
         file.close()
 
-def gauges_sww2csv(sww_file,
+def sww2csv_gauges(sww_file,
                    gauge_file,
                    quantities = ['stage', 'elevation', 'xmomentum', 'ymomentum'],