Index: anuga_work/development/cocos/grid_data.py
===================================================================
--- anuga_work/development/cocos/grid_data.py	(revision 4846)
+++ anuga_work/development/cocos/grid_data.py	(revision 4926)
@@ -19,5 +19,6 @@
 copy_code_files(output_dir,__file__)
 
-start_screen_catcher(output_dir)
+start_screen_catcher(output_dir,verbose=True)
+print'testing'
 
 data_dir='/d/ehn/4/ehn/tsunami/data/bathymetry/Cocos/bathymetry/'
@@ -78,5 +79,5 @@
 #        4.3m2
 
-res = 10
+res = 100
 #G = Geospatial_data(file_name = data_dir_name + '.txt')
 #G1=G.clip(poly1)
@@ -84,5 +85,6 @@
 
 
-interior_polys = [[poly2,(grid2_res**2/2)*res],[poly3,(grid3_res**2/2)*res],[poly4,(grid4_res**2/2)*res]]
+#interior_polys = [[poly2,(grid2_res**2/2)*res],[poly3,(grid3_res**2/2)*res],[poly4,(grid4_res**2/2)*res]]
+interior_polys = [[poly2,(grid2_res**2)*2],[poly3,(grid3_res**2)*res],[poly4,(grid4_res**2)*res]]
 #interior_polys = [[poly4,4.3*res]]
 
@@ -94,8 +96,11 @@
 #                         use_cache=True,
 #                         verbose=True)
+max_tri = (grid1_res**2/2)*res
+print 'max_tri',max_tri
 create_mesh_from_regions(poly1,
 #create_mesh_from_regions(poly3,
                          boundary_tags={'side': [0,1,2,3]},
-                         maximum_triangle_area=(grid1_res**2/2)*res,
+                         maximum_triangle_area=(grid1_res**2)*res,
+#                         maximum_triangle_area=(grid1_res**2)*1,
 #                         maximum_triangle_area=110*res,
                          interior_regions=interior_polys,
@@ -105,14 +110,15 @@
                          
                          
-value, alpha = find_optimal_smoothing_parameter(data_file=data_dir_name_clip + '.txt', 
-                                             alpha_list=[0.0001,0.001,0.01,0.1,1.0],
-#                                             alpha_list=[0.01],
-                                             boundary_poly=poly3,
-                                             mesh_file=mesh_file,
-                                             plot_name=None,
-                                             cache=True,
-                                             verbose=True)
+#value, alpha = find_optimal_smoothing_parameter(data_file=data_dir_name_clip + '.txt', 
+##                                             alpha_list=[0.0001,0.001,0.01,0.1,1.0],
+#                                             alpha_list=[0.1],
+#                                             boundary_poly=poly3,
+#                                             mesh_file=mesh_file,
+#                                             plot_name=None,
+#                                             split_factor=0.1,
+#                                             cache=True,
+#                                             verbose=True)
                                              
-print 'Setup computational domain', value, alpha
+#print 'Setup computational domain', value, alpha
 
     #domain = cache(Domain, (meshes_dir_name), {'use_cache':True, 'verbose':True}, verbose=True)
@@ -126,10 +132,11 @@
                             use_cache = True,
                             verbose = True,
-                            alpha = alpha)
+#                            alpha = alpha)
+                            alpha = 0.01)
 print 'Finished Set quantity'
 
 domain.set_name(sww_file)
 domain.set_datadir(output_dir)
-domain.set_default_order(2) # Apply second order scheme
+domain.set_default_order(1) # Apply second order scheme
 domain.set_minimum_storable_height(0.01) # Don't store anything less than 1cm
 domain.set_store_vertices_uniquely(False)
@@ -150,4 +157,5 @@
                     timestep = None,
                     reduction = max,
+#                    cellsize = grid4_res*sqrt(1),
                     cellsize = grid4_res*sqrt(res),
                     NODATA_value = -9999,
@@ -165,4 +173,5 @@
                     timestep = None,
                     reduction = max,
+#                    cellsize = grid3_res*sqrt(1),
                     cellsize = grid3_res*sqrt(res),
                     NODATA_value = -9999,
@@ -180,5 +189,6 @@
                     timestep = None,
                     reduction = max,
-                    cellsize = grid2_res*sqrt(res),
+                    cellsize = grid2_res*sqrt(1),
+#                    cellsize = grid2_res*sqrt(res),
                     NODATA_value = -9999,
                     easting_min = 224424.96,
@@ -195,4 +205,5 @@
                     timestep = None,
                     reduction = max,
+#                    cellsize = grid1_res*sqrt(1),
                     cellsize = grid1_res*sqrt(res),
                     NODATA_value = -9999,