Index: /anuga_work/production/onslow_2006/convert2latlon.py
===================================================================
--- /anuga_work/production/onslow_2006/convert2latlon.py	(revision 4926)
+++ /anuga_work/production/onslow_2006/convert2latlon.py	(revision 4927)
@@ -30,12 +30,14 @@
 from os import sep
 
-timedir = '20070906_061418_run_final_1.5_jsexton_exmouth_original'
-#filename = project.outputdir + timedir + sep + 'stage0_interp.csv'
+#timedir = '20070608_060316_run_final_1.5_onslow_nbartzis' # HAT 1 in Onslow 10000 yr
+timedir = '20070613_034754_run_final_1.5_dampier_nbartzis'
+#timedir = '20070906_061418_run_final_1.5_jsexton_exmouth_original'
+filename = project.outputdir + timedir + sep + 'stage0_interp.csv'
 #filename = project.outputdir + timedir + sep + 'stage5_interp.csv'
-filename = project.outputdir+ timedir + sep + 'stage20_interp.csv'
+#filename = project.outputdir+ timedir + sep + 'stage20_interp.csv'
 #filename = project.outputdir+  timedir + sep + 'stage80_interp.csv'
-#filename_out = project.outputdir + timedir + sep + 'stage0_convert.csv'
+filename_out = project.outputdir + timedir + sep + 'stage0_convert.csv'
 #filename_out = project.outputdir + timedir + sep + 'stage5_convert.csv'
-filename_out = project.outputdir + timedir + sep + 'stage20_convert.csv'
+#filename_out = project.outputdir + timedir + sep + 'stage20_convert.csv'
 #filename_out = project.outputdir + timedir + sep + 'stage80_convert.csv'
 alter_file(filename,filename_out)
Index: /anuga_work/production/onslow_2006/plot_contour_data.py
===================================================================
--- /anuga_work/production/onslow_2006/plot_contour_data.py	(revision 4926)
+++ /anuga_work/production/onslow_2006/plot_contour_data.py	(revision 4927)
@@ -3,9 +3,11 @@
 
 import project
-from pylab import plot, xlabel, ylabel, savefig, ion, close, axis, title, legend
+from pylab import plot, xlabel, ylabel, savefig, ion, close, axis, title, legend, grid
 from os import sep
  
 directory = project.outputdir
 timedir = '20070906_061418_run_final_1.5_jsexton_exmouth_original'
+#timedir = '20070608_060316_run_final_1.5_onslow_nbartzis'
+#timedir = '20070613_034754_run_final_1.5_dampier_nbartzis'
 
 def get_data(filename):
@@ -32,7 +34,9 @@
 
 from anuga.abstract_2d_finite_volumes.util import greens_law
+from Numeric import arange
 d1 = 80.
-d2 = range(d1,5,-1)
+d2 = arange(d1,0.15,-0.1)
 h1 = max_stage
+#h1 = 4.0
 green = []
 for d in d2:
@@ -46,7 +50,14 @@
 title('ANUGA modelled maximum stage versus Green\'s approximation \n \
 Magnitude 9.3 event (Java) at Onslow')
+#title('ANUGA modelled maximum stage versus Green\'s approximation \n \
+#Magnitude 9.1 event (Sumba) at Onslow')
+#title('ANUGA modelled maximum stage versus Green\'s approximation \n \
+#Magnitude 9.0 event (Sumba) at Onslow')
 legend(['ANUGA','Green\'s law'])
 axis([-5,85,min(stage_max)*0.9,max(stage_max)*1.1])
-savefig('stratification')
+grid(True)
+#savefig('stratification_onslow_gun')
+savefig('stratification_exmouth_gun')
+#savefig('stratification_dampier_gun')
 
 close('all')
Index: /anuga_work/production/pt_hedland_2006/convert2latlon.py
===================================================================
--- /anuga_work/production/pt_hedland_2006/convert2latlon.py	(revision 4927)
+++ /anuga_work/production/pt_hedland_2006/convert2latlon.py	(revision 4927)
@@ -0,0 +1,41 @@
+"""
+Convert Easting Northing to lon/lat for ultimately get kml file
+"""
+
+def alter_file(filename,filenameout):
+
+    from anuga.coordinate_transforms.lat_long_UTM_conversion import UTMtoLL
+    
+    fid = open(filename)
+    lines = fid.readlines()
+    fid.close()
+    
+    fid_out = open(filenameout, 'w')
+    s = '%s,%s,%s\n' %('lon','lat','stage')
+    fid_out.write(s)
+    for line in lines[1:]:
+       fields = line.split(',')
+       easting = float(fields[0])
+       northing = float(fields[1])
+       stage = float(fields[3])
+       lat, lon = UTMtoLL(northing,easting, 50)
+       s = '%f,%f,%f\n' %(lon,lat,stage)
+       fid_out.write(s)
+
+    fid_out.close() 
+
+    return
+
+import project
+from os import sep
+
+timedir='20070613_044204_run_final_3.6_exmouth_nbartzis'
+filename = project.outputdir + timedir + sep + 'stage0_interp.csv'
+#filename = project.outputdir + timedir + sep + 'stage5_interp.csv'
+#filename = project.outputdir+ timedir + sep + 'stage20_interp.csv'
+#filename = project.outputdir+  timedir + sep + 'stage80_interp.csv'
+filename_out = project.outputdir + timedir + sep + 'stage0_convert.csv'
+#filename_out = project.outputdir + timedir + sep + 'stage5_convert.csv'
+#filename_out = project.outputdir + timedir + sep + 'stage20_convert.csv'
+#filename_out = project.outputdir + timedir + sep + 'stage80_convert.csv'
+alter_file(filename,filename_out)
Index: /anuga_work/production/pt_hedland_2006/plot_contour_data.py
===================================================================
--- /anuga_work/production/pt_hedland_2006/plot_contour_data.py	(revision 4927)
+++ /anuga_work/production/pt_hedland_2006/plot_contour_data.py	(revision 4927)
@@ -0,0 +1,62 @@
+"""Read in contour data file and plot max and min
+"""
+
+import project
+from pylab import plot, xlabel, ylabel, savefig, ion, close, axis, title, legend, grid
+from os import sep
+ 
+directory = project.outputdir
+timedir='20070613_044204_run_final_3.6_exmouth_nbartzis'
+
+def get_data(filename):
+    fid = open(filename)
+    lines = fid.readlines()
+    fid.close()
+    stage = []
+    for line in lines[1:]:
+        fields = line.split(',')
+        stage.append(float(fields[2]))
+    return max(stage), min(stage)
+
+files = ['stage0_convert.csv','stage5_convert.csv','stage20_convert.csv','stage80_convert.csv']
+depth = [0,5,20,80]
+stage_max = []
+stage_min = []
+
+for thefile in files:
+
+    filename = directory + timedir + sep + thefile
+    max_stage, min_stage = get_data(filename)
+    stage_max.append(max_stage)
+    stage_min.append(min_stage)
+
+from anuga.abstract_2d_finite_volumes.util import greens_law
+from Numeric import arange
+d1 = 80.
+d2 = arange(d1,0.15,-0.1)
+h1 = max_stage
+#h1 = 4.0
+green = []
+for d in d2:
+    h2 = greens_law(d1,d,h1)
+    green.append(h2)
+    
+ion()
+plot(depth,stage_max,'ob',d2,green,'-g',depth,stage_max,'-b')
+xlabel('depth (m)') 
+ylabel('stage (m)')
+title('ANUGA modelled maximum stage versus Green\'s approximation \n \
+Magnitude 9.3 event (Java) at Pt Hedland')
+#title('ANUGA modelled maximum stage versus Green\'s approximation \n \
+#Magnitude 9.1 event (Sumba) at Pt Hedland')
+#title('ANUGA modelled maximum stage versus Green\'s approximation \n \
+#Magnitude 9.0 event (Sumba) at Pt Hedland')
+legend(['ANUGA','Green\'s law'])
+axis([-5,85,min(stage_max)*0.9,max(stage_max)*1.1])
+grid(True)
+#savefig('stratification_onslow_gun')
+savefig('stratification_exmouth_gun')
+#savefig('stratification_dampier_gun')
+
+close('all')
+