Index: /anuga_work/development/shallow_water_1d/domain_t2.py
===================================================================
--- /anuga_work/development/shallow_water_1d/domain_t2.py	(revision 4959)
+++ /anuga_work/development/shallow_water_1d/domain_t2.py	(revision 4960)
@@ -8,5 +8,5 @@
 """
 from generic_boundary_conditions import *
-from coordinate_transforms.geo_reference import Geo_reference
+#from coordinate_transforms.geo_reference import Geo_reference
 
 class Domain:
@@ -14,5 +14,5 @@
     def __init__(self, coordinates, boundary = None,
                  conserved_quantities = None, other_quantities = None,
-                 tagged_elements = None, geo_reference = None):
+                 tagged_elements = None):
         """
         Build 1D elements from x coordinates
@@ -24,8 +24,8 @@
         self.coordinates = array(coordinates)
 
-        if geo_reference is None:
-            self.geo_reference = Geo_reference() #Use defaults 
-        else:
-            self.geo_reference = geo_reference
+##        if geo_reference is None:
+##            self. = Geo_reference() #Use defaults 
+##        else:
+##            self.geo_reference = geo_reference
 
         #Register number of Elements
Index: /anuga_work/development/shallow_water_1d/dry_dam.py
===================================================================
--- /anuga_work/development/shallow_water_1d/dry_dam.py	(revision 4959)
+++ /anuga_work/development/shallow_water_1d/dry_dam.py	(revision 4960)
@@ -118,8 +118,8 @@
     k = k+1
     print 'That took %.2f seconds' %(time.time()-t0)
-    X = domain.vertices
-    StageQ = domain.quantities['stage'].vertex_values
-    XmomQ = domain.quantities['xmomentum'].vertex_values
-    h, uh = analytical_sol(X.flat,domain.time)
+    X = domain.vertices.flat
+    StageQ = domain.quantities['stage'].vertex_values.flat
+    XmomQ = domain.quantities['xmomentum'].vertex_values.flat
+    h, uh = analytical_sol(X,domain.time)
     #from pylab import * # this command stuffs up setting of new domain
     from pylab import plot,title,xlabel,ylabel,legend,savefig,show,hold,subplot
Index: /anuga_work/development/shallow_water_1d/dry_dam_sudi.py
===================================================================
--- /anuga_work/development/shallow_water_1d/dry_dam_sudi.py	(revision 4959)
+++ /anuga_work/development/shallow_water_1d/dry_dam_sudi.py	(revision 4960)
@@ -124,12 +124,13 @@
     XmomQ = domain.quantities['xmomentum'].vertex_values
     h, uh = analytical_sol(X.flat,domain.time)
-  
+    x = X.flat
+    
     from pylab import plot,title,xlabel,ylabel,legend,savefig,show,hold,subplot
-    print 'test2'
+    print 'test 2'
     hold(False)
     print 'test 3'
     plot1 = subplot(211)
     print 'test 4'
-    plot(X,h,X,StageQ)
+    plot(x,h,x,StageQ.flat)
     print 'test 5'
     plot1.set_ylim([-1,11])
@@ -139,5 +140,5 @@
            'upper right', shadow=True)
     plot2 = subplot(212)
-    plot(X,uh,X,XmomQ)
+    plot(x,uh,x,XmomQ.flat)
     plot2.set_ylim([-35,35])
     
Index: /anuga_work/development/shallow_water_1d/shallow_water_1d.py
===================================================================
--- /anuga_work/development/shallow_water_1d/shallow_water_1d.py	(revision 4959)
+++ /anuga_work/development/shallow_water_1d/shallow_water_1d.py	(revision 4960)
@@ -51,6 +51,5 @@
 class Domain(Generic_Domain):
 
-    def __init__(self, coordinates, boundary = None, tagged_elements = None,
-                 geo_reference = None):
+    def __init__(self, coordinates, boundary = None, tagged_elements = None):
 
         conserved_quantities = ['stage', 'xmomentum']
@@ -58,5 +57,5 @@
         Generic_Domain.__init__(self, coordinates, boundary,
                                 conserved_quantities, other_quantities,
-                                tagged_elements, geo_reference)
+                                tagged_elements)
         
         from config import minimum_allowed_height, g
Index: /anuga_work/development/shallow_water_1d/shallow_water_h.py
===================================================================
--- /anuga_work/development/shallow_water_1d/shallow_water_h.py	(revision 4959)
+++ /anuga_work/development/shallow_water_1d/shallow_water_h.py	(revision 4960)
@@ -51,6 +51,5 @@
 class Domain(Generic_Domain):
 
-    def __init__(self, coordinates, boundary = None, tagged_elements = None,
-                 geo_reference = None):
+    def __init__(self, coordinates, boundary = None, tagged_elements = None):
 
         conserved_quantities = ['height', 'xmomentum']
@@ -58,5 +57,5 @@
         Generic_Domain.__init__(self, coordinates, boundary,
                                 conserved_quantities, other_quantities,
-                                tagged_elements, geo_reference)
+                                tagged_elements)
         
         from config import minimum_allowed_height, g